			;NASM-IDE ASM Assistant Assembler Project File
[BITS 16]		;Set code generation to 16 bit mode
[ORG 0x0100]		;Set code start address to 0100h


[SEGMENT .text]		;Main code segment

         jmp MAIN       ;salto all'inizio del programma
         nop
         
PRINTS:                 ;Subroutine per stampare una stringa
         mov dx,ax      ;metto la stringa da stampare in dx
         mov ah,0x09    ;richiedo il servizio n9
         int 0x21       ;stampo la stringa a Video (int del DOS)
         ret            ;torno indietro da chi mi ha invocato

PRINTC:                 ;Subroutine per stampare un carattere
         mov dx,ax      ;metto il carattere in dx
         mov ah,0x02    ;richiedo il servizio n2
         int 0x21       ;stampo il carattere a Video (int del DOS)
         ret

RESETCONTROLLER:
         xor ax,ax      ;Subroutine per resettare il controller
         xor dx,dx      ;0x00 = Floppy A
         int 0x13       ;reset controller (int del BIOS)
         ret

PRINTHEX:               ;Stampa il numero in DX in esadecimale (4cifre)
         pushad         ;salvo tutti i registri...
         mov     cl, dh
         and     cl, 11110000b
         shr     cl, 4
         xor     bx, bx
         mov     bl, cl
         mov     ah, [hexval+bx]
         mov     [hexstr+3], ah

         mov     cl, dh
         and     cl, 00001111b
         xor     bx, bx
         mov     bl, cl
         mov     ah, [hexval+bx]
         mov     [hexstr+2], ah

         mov     cl, dl
         and     cl, 11110000b
         shr     cl, 4
         xor     bx, bx
         mov     bl, cl
         mov     ah, [hexval+bx]
         mov     [hexstr+1], ah

         mov     cl, dl
         and     cl, 00001111b
         xor     bx, bx
         mov     bl, cl
         mov     ah, [hexval+bx]
         mov     [hexstr], ah

         mov     ax, 0900h
         mov     dx, hexstr
         int     21h
         popad          ;...e li rimetto a posto
         ret

WRITEFILE:
         mov dx,FileName     ;Subroutine per scrivere un file su disco
         xor cx,cx           ;cx=0x00 nessun attributo speciale
         mov ah,0x3c         ;servizio 0x3c = CREA FILE
         int 0x21            ;apro un file di nome 'BOOT.BIN'
         jc ERRCR            ;ERRORE in creazione?
         mov [fh],ax         ;no,allora salvo filehandle
         mov bx,ax           ;e lo metto anche in bx
         mov dx,trackbuffer  ;punto alla mio buffer di traccia appena letto
         mov cx,512          ;voglio salvare 512 byte dal buffer
         push cx             ;lo salvo, cos dopo lo confronto
         mov ah,0x40         ;servizio 0x40 = SALVA SU FILE
         int 0x21            ;scrivo nel file appena creato
         jc ERRWR            ;ERRORE in scrittura ?
         pop cx              ;no, allora ripesco il numero di byte da scrivere
         cmp ax,cx           ;e lo confronto con quelli realmente scritti
         jne ERRWRNB         ;ERRORE nella quantit di byte scritti?
         mov bx,[fh]         ;no,allora ripesco il file handle
         mov ah,0x3e         ;servizio 0x3e = CHIUDI FILE
         int 0x21            ;chiudo il file
         jc ERRCL            ;ERRORE in chiusura?
         ret                 ;no, allora torna a casa!!
ERRCR:
         mov ax,ErrCreateFile
         call PRINTS
         jmp EXIT2DOS

ERRWR:
         mov ax,ErrWriteFile
         call PRINTS
         jmp EXIT2DOS
ERRWRNB:
         mov ax,ErrWriteByteFile
         call PRINTS
         jmp EXIT2DOS
ERRCL:
         mov ax,ErrCloseFile
         call PRINTS
         jmp EXIT2DOS


ERRPRINT:
         mov dx,ax
         call PRINTHEX
         mov ax,bx
         call PRINTS
         jmp EXIT2DOS
;-------------------------------
;inizio del corpo del programma:
;---------------------------------------------------

MAIN:
         call RESETCONTROLLER     ; RESETTA IL CONTROLLER DEL FLOPPY
         jnc  READTRK             ; SE TUTTO OK VAI A LEGGERE LA TRACCIA 0
         mov bx,ControllerNO      ; E IL MESSAGGIO
         jmp ERRPRINT             ; ED ESCE AL DOS

READTRK:
         dec BYTE [try]      ;try  inizialmente a 5
         cmp BYTE [try],0x00 ;provo 5 volte a leggere
         je READERROR        ;...a questo punto  proprio errore!
         mov ax, 0x0201      ;voglio leggere un settore
         mov cx, 0x0001      ;traccia 0 settore 1
         mov dx, 0x0000      ;testina 0 floppy a:
         mov bx, trackbuffer ;[es:bx]  il buffer della traccia letta
         int 0x13            ;vai a leggere
         jnc PRINTBUFF       ;SE TUTTO OK VISUALIZZA CIO' CHE HAI LETTO
         cmp ah,0x80         ;non c'e il floppy nel drive?
         je NOFLOPPY         ;c'e', ma l'errore  di lettura!
         cmp ah,0x06         ;il floppy  cambiato?
         je READTRK


READERROR:
         mov bx,ReadError    ;errore in lettura
         jmp ERRPRINT        ;messaggino e si esce al DOS

NOFLOPPY:
         mov bx,NoFloppy     ;non c'e' e te lo dico anche!
         jmp ERRPRINT        ;messaggino e si esce al DOS


PRINTBUFF:                   ;STAMPA CONTENUTO BUFFER....
         call WRITEFILE      ; e lo salva in BOOT.BIN
         mov cx, 256         ;per 512 byte (256 WORD)
         xor bx,bx           ;azzero bx
CICLO:                       ;
         mov WORD dx,[trackbuffer+bx]    ;CARICA DX COL VALORE DA STAMPARE
         call PRINTHEX       ;LO STAMPA....
         inc bx              ;
         inc bx              ;AVANTI DUE BYTE (1 WORD)
         loop CICLO          ;..FINO ALLA FINE DEL BUFFER

EXIT2DOS:
         mov ah, 0x4c        ; This function exits the program
         int 0x21            ; and returns control to DOS.

;**************************************************
[SEGMENT .data]		;Initialised data segment

; MESSAGGI DI ERRORE DEL PROGRAMMA
ReadError    db 'Errore in lettura...', 13, 10, '$'
FmtMessageNO db 'Formattazione fallita..', 13, 10, '$'
ControllerOK db 'Controller Resettato con successo!', 13, 10, '$'
ControllerNO db 'Errore nel reset del controller..', 13, 10, '$'
NoFloppy     db 'Nessun floppy nel Drive A: !!', 13, 10, '$'


;Messaggi di errore per la routine WRITEFILE
FileName      db 'boot.bin',0 ,'$'     ; scrive nella dir corrente
ErrCreateFile db 'Errore in creazione del file', 13, 10, '$'
ErrWriteFile  db 'Errore in scrittura sul file', 13, 10, '$'
ErrWriteByteFile  db 'Errore nbyte scritti sul file', 13, 10, '$'
ErrCloseFile  db 'Errore in chiusura del file', 13, 10, '$'

; per la conversione e la stampa in esadecimale:
hexval db '0123456789ABCDEF','$'
hexstr db 00, 00, 00, 00, ',', '$'

; tre tentativi di lettura prima di abortire
try db 06
;**************************************************
[SEGMENT .bss]		;Uninitialised data segment

trackbuffer resb 512    ;buffer di traccia
fh          resw 1      ;filehandle


;**************************************************
;CODICI DI ERRORE PRESI DA INTLIST DI RALF BROWN
;**************************************************
;
; 00h	successful completion
; 01h	invalid function in AH or invalid parameter
; 02h	address mark not found
; 03h	disk write-protected
; 04h	sector not found/read error
; 05h	reset failed (hard disk)
; 05h	data did not verify correctly (TI Professional PC)
; 06h	disk changed (floppy)
; 07h	drive parameter activity failed (hard disk)
; 08h	DMA overrun
; 09h	data boundary error (attempted DMA across 64K boundary or >80h sectors)
; 0Ah	bad sector detected (hard disk)
; 0Bh	bad track detected (hard disk)
; 0Ch	unsupported track or invalid media
; 0Dh	invalid number of sectors on format (PS/2 hard disk)
; 0Eh	control data address mark detected (hard disk)
; 0Fh	DMA arbitration level out of range (hard disk)
; 10h	uncorrectable CRC or ECC error on read
; 11h	data ECC corrected (hard disk)
; 20h	controller failure
; 31h	no media in drive (IBM/MS INT 13 extensions)
; 32h	incorrect drive type stored in CMOS (Compaq)
; 40h	seek failed
; 80h	timeout (not ready)
; AAh	drive not ready (hard disk)
; B0h	volume not locked in drive (INT 13 extensions)
; B1h	volume locked in drive (INT 13 extensions)
; B2h	volume not removable (INT 13 extensions)
; B3h	volume in use (INT 13 extensions)
; B4h	lock count exceeded (INT 13 extensions)
; B5h	valid eject request failed (INT 13 extensions)
; BBh	undefined error (hard disk)
; CCh	write fault (hard disk)
; E0h	status register error (hard disk)
; FFh	sense operation failed (hard disk)

; Copied from Ralf Brown's Interrupt List